function [outp, coeffs, best, geoerr, dims] = computeGeoFlowLin(im, fx, fy, ft, fxx, fyy, ftt, fxy, fyt, fxt, ...
                                                    xstart, ystart, tstart, height, width, time, thresh)

                                                
[pwy pwx ptime] = size(im);
NORMALIZE_SPLINES = 1;
DISPLAY = 0;
index = 1;
for lx=1:log2(ptime)
    dimx = (ptime/(2^lx));
    dimalpha = dimx;
    exp_lx = 2^-lx;
    
    [B_alph hede] = meshgrid(1:ptime, 1:dimx);
    for k=1:dimx
        tmp = 1 - abs(exp_lx*B_alph(k,:)-k);
        list = find(tmp < 0);
        tmp(list) = 0;
        B_alph(k,:) = tmp;
    end
    if NORMALIZE_SPLINES
        for t=1:ptime
            if(sum(B_alph(:,t))~=1)
                B_alph(1,t) = 1;
            end
        end
    end        
    
    for ly=1:log2(ptime)
        dimy = (ptime/(2^ly));
        dimbeta = dimy;
        exp_ly = 2^-ly;
        [B_beta hede] = meshgrid(1:ptime, 1:dimy);
        for k=1:dimy
            tmp = 1 - abs(exp_ly*B_beta(k,:)-k);
            list = find(tmp < 0);
            tmp(list) = 0;
            B_beta(k,:) = tmp;
        end
        if NORMALIZE_SPLINES
            for y=1:ptime
                if(sum(B_beta(:,y))~=1)
                    B_beta(1,y) = 1;
                end
            end
        end
        
        [err1, cp1, cp2, alpha1, beta1, b1, b2] = findCoeffs3D_T_ct_ct_1(im, ptime, lx, ly, fxx, fyy, fxy, fxt, fyt, ftt, fx, fy, ft);
        alpha_f = alpha1;
        beta_f = beta1;
%         alpha_f = round(alpha_f/0.125)*0.125;
%         beta_f = round(beta_f/0.125)*0.125;
        
        cpx = zeros(ptime,1);
        for t=1:ptime
            cpx(t) = alpha_f*b1(:,t);
        end
        
        cpy = zeros(ptime,1);
        for t=1:ptime
            cpy(t) = beta_f*b2(:,t);
        end
        clear err
        for t=1:ptime
            err(:,:,t) = fx(:,:,t)*cpx(t) + fy(:,:,t)*cpy(t) + ft(:,:,t);
        end
        err = sum(err(:).^2);
        % save the outputs
        coeffs(index).x = cpx;
        coeffs(index).y = cpy;
        dims(index,:) = [lx, ly];
        outp(index) = err;
        index = index+1;
    end
end

[err, ind] = min(outp);
best.cx = coeffs(ind).x;
best.cy = coeffs(ind).y;
geoerr = outp(ind);