function [lines_x, lines_y] = computeMap(pwy, pwx, ptime, coeffs)

if max(abs(coeffs.x)>5 | abs(coeffs.y)>5)
    coeffs.x(:) = 0;
    coeffs.y(:) = 0;
end
    
global lambda pwmax coefbit gamma startx starty
% compute the lines
for tt=1:ptime
    surf_x(tt) = sum(coeffs.x(1:tt));
    surf_y(tt) = sum(coeffs.y(1:tt));
end

%find the line extrema
xmax = ceil(max(surf_x));
ymax = ceil(max(surf_y));
xmin = floor(min(surf_x));
ymin = floor(min(surf_y));
xstepsize = 40;
ystepsize = 40;
xstart = startx-xmax;
xend = startx+pwx-xmin;
ystart = starty-ymax;
yend = starty+pwy-ymin;
% if xmax==xmin
%     xstepsize = 0;
%     xstart = 1;
%     xend = pwx;
% end
% if ymax==ymin
%     ystepsize = 0;
%     ystart = 1;
%     yend = pwy;
% end
LOOPFLAG = 1;
counter = 0;
while (LOOPFLAG & counter<10)
    clear lines_x lines_y lines_t
    [lines_x lines_y, lines_t] = meshgrid(xstart:xend, ystart:yend, 1:ptime);
    for tt=1:ptime
        lines_x(:,:,tt) = (lines_x(:,:,tt) + surf_x(tt));
        lines_y(:,:,tt) = (lines_y(:,:,tt) + surf_y(tt));
    end
    
    lsy = find((lines_y(:) > starty+pwy-1+0.5) | (lines_y(:) <= starty-0.5));
    lines_x(lsy) = nan;
    lines_y(lsy) = nan;
    
    lsx = find((lines_x(:) > startx+pwx-1+0.5) | (lines_x(:) <= startx-0.5));
    lines_x(lsx) = nan;
    lines_y(lsx) = nan;
    [szy szx szt] = size(lines_x);    
    if 0
        for t=1:ptime
            [size(find(~isnan(lines_x(:,:,t)))), size(find(~isnan(lines_y(:,:,t)))) pwy*pwx]
        end
    end
    ls = find(~isnan(lines_x(:)));
    if max(size(ls(:))) == (pwy*pwx*ptime)
        LOOPFLAG = 0;
    else
        xstart = xstart-xstepsize;
        xend = xend+xstepsize;
        ystart = ystart-ystepsize;
        yend = yend+ystepsize;
        [xstart ystart xend yend xmax+xstart max(size(ls)) (pwy*pwx*ptime)];
    end
    counter = counter+1;
end
if counter>=10
    sprintf('hede');
    recimg = [];
    recerr = inf;
    bandcoef = [];
    bitcost = [];
    return
end
lines_y(lsy) = nan;
lines_t(lsy) = nan;
    
lines_y(lsx) = nan;
lines_t(lsx) = nan;

[gry, grx grt] = size(lines_x);
for x=1:grx
    nantest = isnan(lines_x(:,x,:));
    if ~isempty(find(nantest==0))
        xmin = x;
        break;
    end
end
for x=grx:-1:1
    nantest = isnan(lines_x(:,x,:));
    if ~isempty(find(nantest==0))
        xmax = x;
        break;
    end
end


for y=1:gry
    nantest = isnan(lines_x(y,:,:));
    if ~isempty(find(nantest==0))
        ymin = y;
        break;
    end
end
for y=gry:-1:1
    nantest = isnan(lines_x(y,:,:));
    if ~isempty(find(nantest==0))
        ymax = y;
        break;
    end
end


% coords = coords(ymin:ymax, xmin:xmax,:);
lines_x = lines_x(ymin:ymax, xmin:xmax,:);
lines_y = lines_y(ymin:ymax, xmin:xmax,:);
% [coordx coordy coordt] = meshgrid(1:pwx, 1:pwy, 1:ptime);
% ls = find(~isnan(lines_x));
% grx = lines_x;
% grx(ls) = coordx;
% gry = lines_y;
% gry(ls) = coordy;
% map = lines_x;
% map(ls) = 1:pwy*pwx*ptime;