function img = cropGOF(orig, pw, pwt, colorim)

global timestep
[height width time] = size(orig);
% gof for temporal direction
for t=1:time-1
    [im_x(:,:,t) im_y(:,:,t) im_t(:,:,t)] = computeDerivatives2(orig(:,:,t), orig(:,:,t+1));
end
 
toffset = mod(time, timestep);
xoffset = mod(width, pw);
yoffset = mod(height, pw);
newh = height-yoffset;
neww = width-xoffset;
newt = time-toffset;

img.im = orig(3:3+newh-1, 3:3+neww-1, 3:3+newt-1);
img.colorim = colorim(3:3+newh-1, 3:3+neww-1, :, 3:3+newt-1);
img.imresample = orig(3:3+newh-1, 3:3+neww-1, 3:3+newt);
img.imx = im_x(1:newh, 1:neww, 3:3+newt-1);
img.imy = im_y(1:newh, 1:neww, 3:3+newt-1);
img.imt = im_t(1:newh, 1:neww, 3:3+newt-1);

% % gof for horizontal direction
% imgh = flipSequence(orig, 1);
% for t=1:width-1
%     [imh_x(:,:,t) imh_y(:,:,t) imh_t(:,:,t)] = computeDerivatives2(imgh(:,:,t), imgh(:,:,t+1));
% end
% 
% % orig = orig(3:height-2, 3:width-2, 1:time-1);
% 
% img.imh = imgh(3:3+newh-1, 3:3+newt-1, 3:3+neww-1);
% img.imhresample = imgh(3:3+newh-1, 3:3+newt-1, 3:3+neww);
% img.imhx = imh_x(1:newh, 1:newt, 3:3+neww-1);
% img.imhy = imh_y(1:newh, 1:newt, 3:3+neww-1);
% img.imht = imh_t(1:newh, 1:newt, 3:3+neww-1);
% %reshape the gradients
% img.imhx = flipSequence(img.imhx,1);
% img.imhy = flipSequence(img.imhy,1);
% img.imht = flipSequence(img.imht,1);
% img.imh = flipSequence(img.imh,1);
% 
% % gof for vertical direction
% imgv = flipSequence(orig, 2);
% for t=1:height-1
%     [imv_x(:,:,t) imv_y(:,:,t) imv_t(:,:,t)] = computeDerivatives2(imgv(:,:,t), imgv(:,:,t+1));
% end
% 
% img.imv = imgv(3:3+newt-1, 3:3+neww-1, 3:3+newh-1);
% img.imvresample = imgv(3:3+newt-1, 3:3+neww-1, 3:3+newh);
% img.imvx = imv_x(1:newt, 1:neww, 3:3+newh-1);
% img.imvy = imv_y(1:newt, 1:neww, 3:3+newh-1);
% img.imvt = imv_t(1:newt, 1:neww, 3:3+newh-1);
% %reshape the gradients
% img.imv = flipSequence(img.imv,2);
% img.imvx = flipSequence(img.imvx,2);
% img.imvy = flipSequence(img.imvy,2);
% img.imvt = flipSequence(img.imvt,2);
% 
% if 0
%     [nh, nw, nt] = size(img.im)
%     % gof
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.im(:,:,t));
%         colormap(gray(255))
%     end
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.imh(:,:,t));
%         colormap(gray(255))
%     end
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.imv(:,:,t));
%         colormap(gray(255))
%     end
% 
%     % gof_x
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.imx(:,:,t));
%         colormap(gray(255))
%     end
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.imhx(:,:,t));
%         colormap(gray(255))
%     end
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.imvx(:,:,t));
%         colormap(gray(255))
%     end
% 
%     %gof_y
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.imy(:,:,t));
%         colormap(gray(255))
%     end
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.imhy(:,:,t));
%         colormap(gray(255))
%     end
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.imvy(:,:,t));
%         colormap(gray(255))
%     end
% 
%     % gof_t
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.imt(:,:,t));
%         colormap(gray(255))
%     end
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.imht(:,:,t));
%         colormap(gray(255))
%     end
%     figure
%     for t=1:nt
%         subplot(4,2,t)
%         imagesc(img.imvt(:,:,t));
%         colormap(gray(255))
%     end
% end
% hee=0;