function [E, alpha] = findL_horizontal(fx, fy, l, im)

global VERT imname
[patchWidth width] = size(fx);
n = patchWidth/(2^l);
M = zeros(1,n);
S = zeros(n,n);
exp_l = 2^-l;
if(1)
    fx = fx/255;
    fy = fy/255;
end

[b hede] = meshgrid(1:patchWidth, 1:n);
for k=1:n
    tmp = 1 - abs(exp_l*b(k,:)-k);
    list = find(tmp < 0);
    tmp(list) = 0;
    b(k,:) = tmp;
end
% compute alpha
fxy = fx.*fy;
fxx = fx.*fx;
for k=1:n
    for y=1:patchWidth
        lst = find(~isnan(fxy(y,:)));
        M(k) = M(k) + b(k,y)*sum(fxy(y,lst));
%         M(k) = M(k) + b(k,y)*sum(fxy(y,:));
        S(:,k) = S(:,k) + b(k,y)*sum(fxx(y,lst))*b(:,y);
%         S(:,k) = S(:,k) + b(k,y)*sum(fxx(y,:))*b(:,y);
        if(isnan(M(k)) | ~isempty(find(isnan(S))))
            return;
        end
    end
end

alpha = -M*inv(S);

c_pr = alpha*b;
E = horizontal_gf_error(fx, fy, l, alpha, c_pr);

if 1
    % find the vector field tangents
    vect_y = ones(patchWidth, patchWidth);
    vect_x = vect_y;
    for x=1:patchWidth
        vect_x(:,x) = c_pr';
    end
    figure
    colormap(gray(255));
    imagesc((fx));
    hold
    if VERT
        quiver(flipud(vect_x), flipud(vect_y))
    else
        quiver(flipud(vect_y), flipud(vect_x))
    end
    title(sprintf('E = %f', E));
    pause
end

if 1
    pixcolor = 255*[0 1 0; 0 0 1; 1 1 0; 0 1 1; 1 0 1];
    pw = patchWidth;
    [gx gy] = meshgrid(1:pw,-2*pw:2*pw);
    for x=1:pw
        cx(x) = sum(vect_x(1:x,1));
        gy(:,x) = gy(:,x) +cx(x);
    end
    gy = round(gy);
    ls = find(gy<1 | gy>pw);
    gy(ls) = nan;
    tmp = im;
    newim = zeros(pw,pw,3);
    newim(:,:,1) = im;
    newim(:,:,2) = im;
    newim(:,:,3) = im;
    origim(:,:,1) = im;
    origim(:,:,2) = im;
    origim(:,:,3) = im;
    flowim = newim;
    flowwidth = 3;
    %     newim = 1-newim;
    if 1
        h = figure;
        pntset =1:15:4*pw;
        pntsz = max(size(pntset))
        picind=0;
        for sz=1:pntsz
            for x=1:pw
                a = gy(pntset(sz),x);
                if(~isnan(a))
                    if(a>=1 & a<=pw)
                        picind = picind + 1;
                        newim(a,x,:) = pixcolor(mod(sz,5)+1,:);
                        origim(pntset(sz)-2*pw,x,:) = pixcolor(mod(sz,5)+1,:);
                    end
                end
            end
        end
    end
    close all
    if 1
        h=figure;
        if VERT
            tmpim(:,:,1) = newim(:,:,1)';
            tmpim(:,:,2) = newim(:,:,2)';
            tmpim(:,:,3) = newim(:,:,3)';
            imagesc(tmpim/255), colormap(gray(255));
            hold on 
            q = quiver(vect_x, vect_y);
%             a = findobj(h);
%             set(findobj(a, 'type', 'line'), 'LineWidth', flowwidth);
            saveas(h, sprintf('lineImg_Vert.tif', y));
        else
            imagesc(newim/255);
            hold on
%             a = findobj(h);
%             set(findobj(a, 'type', 'line'), 'LineWidth', flowwidth);
            q = quiver(vect_y, vect_x);
%             a = findobj(h);
%             set(findobj(a, 'type', 'line'), 'LineWidth', flowwidth);
%             saveas(h, sprintf('lineImg_Horz.tif', y));
        end
    end
    pause
end
