function [E, alpha] = findL_horizontal2(fx, fy, l, im, origim)

global VERT imname
[patchWidth width] = size(fx);
n = patchWidth/(2^l);
M = zeros(1,n);
S = zeros(n,n);
exp_l = 2^-l;
if(1)
    fx = fx/255;
    fy = fy/255;
end

[b hede] = meshgrid(1:patchWidth, 1:n);
for k=1:n
    tmp = 1 - abs(exp_l*b(k,:)-k);
    list = find(tmp < 0);
    tmp(list) = 0;
    b(k,:) = tmp;
end
% compute alpha
fxy = fx.*fy;
fxx = fx.*fx;
for k=1:n
    for y=1:patchWidth
        lst = find(~isnan(fxy(y,:)));
        M(k) = M(k) + b(k,y)*sum(fxy(y,lst));
%         M(k) = M(k) + b(k,y)*sum(fxy(y,:));
        S(:,k) = S(:,k) + b(k,y)*sum(fxx(y,lst))*b(:,y);
%         S(:,k) = S(:,k) + b(k,y)*sum(fxx(y,:))*b(:,y);
        if(isnan(M(k)) | ~isempty(find(isnan(S))))
            return;
        end
    end
end

alpha = -M*inv(S);

c_pr = alpha*b;
E = horizontal_gf_error(fx, fy, l, alpha, c_pr);

if 1
    % find the vector field tangents
    vect_y = ones(patchWidth, patchWidth);
    vect_x = vect_y;
    for x=1:patchWidth
        vect_x(:,x) = c_pr';
    end
    h=figure; colormap(gray(255));
    subplot(2,2,2), imagesc(im);
    hold
    if VERT
        quiver(flipud(vect_x), flipud(vect_y))
    else
        quiver(flipud(vect_y), flipud(vect_x))
    end
    hold off
    title(sprintf('E = %f', E));
%     saveas(h, sprintf('results/%s_flow%02d.tif', imname, l));
end

if 1
    pw = patchWidth;
    [gx gy] = meshgrid(1:pw,-2*pw:2*pw);
    for x=1:pw
        cx(x) = sum(vect_x(1:x,1));
        gy(:,x) = gy(:,x) +cx(x);
    end
    gy = round(gy);
    ls = find(gy<1 | gy>pw);
    gy(ls) = nan;
    gx(ls) = nan;
    gr = gy + (gx-1)*pw;
    gr = boundingBox(gr);
    warpedim = gr;
    newwarpedim = warpedim;
    lst = find(~isnan(gr));
    im = im';
    warpedim(lst) = im(gr(lst));
    
%     figure, imagesc(warpedim), colormap(gray)
    
    [gh, gw] = size(gr);
    if 1
        for y=1:gh
            grlst = find(~isnan(gr(y,:)));
            pixvector = warpedim(y,grlst);
            nanlst = find(isnan(pixvector));
            if ~isempty(nanlst)
                newpixvector = completeData(pixvector, nanlst);
                newwarpedim(y,grlst) = newpixvector;
            else
                newwarpedim(y,:) = warpedim(y,:);
            end
        end
    end
    newim = im;
    newim(gr(lst)) = newwarpedim(lst);
    subplot(2,2,1), imagesc(im)
    title('original image')
    subplot(2,2,3), imagesc(newim)
    title('completed image')
%     if VERT
%         errimg = abs(origim-newim);
%     else
        errimg = abs(origim-newim');
%     end
    subplot(2,2,4), imagesc(errimg)
    title(sprintf('error image, max: %.1f', max(errimg(:))))
    maximize(h)
    saveas(h, sprintf('results/%s_results%02d.tif', imname, l));
    h=figure; colormap(gray(255));
    subplot(1,2,1), imagesc(warpedim)
    title('original warped image')
    subplot(1,2,2), imagesc(newwarpedim)
    title('new warped image')
    maximize(h)
    saveas(h, sprintf('results/%s_warpedresults%02d.tif', imname, l));
    %     pause
    close all
    if 0
        h=figure;
        if VERT
            tmpim(:,:,1) = newim(:,:,1)';
            tmpim(:,:,2) = newim(:,:,2)';
            tmpim(:,:,3) = newim(:,:,3)';
            imagesc(tmpim/255), colormap(gray(255));
            hold on 
            q = quiver(vect_x, vect_y);
%             a = findobj(h);
%             set(findobj(a, 'type', 'line'), 'LineWidth', flowwidth);
            saveas(h, sprintf('lineImg_Vert.tif', y));
        else
            imagesc(newim/255);
            hold on
%             a = findobj(h);
%             set(findobj(a, 'type', 'line'), 'LineWidth', flowwidth);
            q = quiver(vect_y, vect_x);
%             a = findobj(h);
%             set(findobj(a, 'type', 'line'), 'LineWidth', flowwidth);
%             saveas(h, sprintf('lineImg_Horz.tif', y));
        end
    end
end
