function flow_main(im, fnum, colorim)

global pwmax timestep level sequence startx starty RECOMPUTEGOF  RECOMPUTEFLOW REPAIRVIDEO


hd = sprintf('croppedGOF_%s_f%02d_%02d', sequence, fnum, fnum+timestep);
if RECOMPUTEGOF
    img = cropGOF(im(starty-5:starty+pwmax+4, startx-5:startx+pwmax+4,:), pwmax, timestep, ...
        colorim(starty-5:starty+pwmax+4, startx-5:startx+pwmax+4,:,:));
    save(hd, 'img');
else
    load(hd);
end
    
img.origim = im(:,:,3:10);
colorim(starty-3:starty+pwmax-4, startx-3:startx+pwmax-4,:,6);
img.origcolorim = colorim(:,:,:,3:10);
% img.colorim = img.colorim(starty:starty+pwmax-1, startx:startx+pwmax-1,:,:);
% img.im = img.im(starty:starty+pwmax-1, startx:startx+pwmax-1,:);
% img.imx = img.imx(starty:starty+pwmax-1, startx:startx+pwmax-1,:);
% img.imy = img.imy(starty:starty+pwmax-1, startx:startx+pwmax-1,:);
% img.imt = img.imt(starty:starty+pwmax-1, startx:startx+pwmax-1,:);
img.tempcolorim = img.colorim(1:pwmax-1, 1:pwmax-1, :,:);
% compute the flow
hd = sprintf('flow_%s_f%02d_%02d', sequence, fnum, fnum+timestep);
if RECOMPUTEFLOW
    [tflow, geoerrt] = processSequence(img, 1, pwmax, timestep);
    save(hd, 'tflow');
else
    load(hd);
end

scale = 16;
[height width tmp] = size(img.im);
[origheight origwidth ch tmp] = size(img.origcolorim);
[gx gy] = meshgrid(8:scale:width, 8:scale:height);
lst = (gx(:)-1)*height + gy(:);

if 1
    maxlevel = length(tflow.geo.coeffs);
    for lv=1:maxlevel;
        lv
        hd = sprintf('repaired_%s_f%02d_%02d_ind%02d', sequence, fnum, fnum+timestep, lv);
        if REPAIRVIDEO 
            [grx, gry] = computeMap(height, width, tmp, tflow.geo.coeffs(lv));
            temp = reshape(img.origcolorim(:,:,1,:), origheight, origwidth, tmp);
            resim = resampleGOF2(temp, grx, gry, height, width);
            newimR = completeVideo(grx, resim, tflow.geo.coeffs(lv));
            finalim(:,:,1,:) = reconstructGOF(newimR, grx, gry);
            if isempty(newimR)
                continue;
            end
            temp = reshape(img.origcolorim(:,:,2,:), origheight, origwidth, tmp);
            resim = resampleGOF2(temp, grx, gry, height, width);
            newimG = completeVideo(grx, resim, tflow.geo.coeffs(lv));
            temp = reshape(img.origcolorim(:,:,3,:), origheight, origwidth, tmp);
            resim = resampleGOF2(temp, grx, gry, height, width);
            newimB = completeVideo(grx, resim, tflow.geo.coeffs(lv));
            save(hd, 'newimR', 'newimG', 'newimB', 'grx', 'gry');
        else
            load(hd);
        end
        
        finalim(:,:,1,:) = reconstructGOF(newimR, grx, gry);
        finalim(:,:,2,:) = reconstructGOF(newimG, grx, gry);
        finalim(:,:,3,:) = reconstructGOF(newimB, grx, gry);
        
        img.tempim(:,:,1,:) = img.im(1:pwmax-1, 1:pwmax-1, :,:);
        img.tempim(:,:,2,:) = img.im(1:pwmax-1, 1:pwmax-1, :,:);
        img.tempim(:,:,3,:) = img.im(1:pwmax-1, 1:pwmax-1, :,:);
        lst = find(~isnan(img.tempim));
        finalim(lst) = img.tempcolorim(lst);
        
        if 1
            h1=figure;
            h2=figure;
            for t=1:timestep
                figure(h1)
                imagesc(img.tempcolorim(:,:,:,t)/255), colormap(gray(255))
                figure(h2)
                imagesc(finalim(:,:,:,t)/255), colormap(gray(255))
                pause
            end
        end

        img.newcolorim = img.origcolorim;
        img.newcolorim(starty-3:starty+pwmax-5, startx:startx+pwmax-2, :,:) = ...
            finalim(:, :, :,:);
%         finalflow.x = zeros(size(img.im));
%         finalflow.y = zeros(size(img.im));
%         h=figure;
%         for t=1:timestep
%             finalflow.x(:,:,t) = tflow.geo.coeffs(lv).x(t);
%             finalflow.y(:,:,t) = tflow.geo.coeffs(lv).y(t);
%         end
%         for tt=1:timestep
%             v = finalflow.x(:,:,tt);
%             u = finalflow.y(:,:,tt);
%             u = reshape(u(lst), height/scale, width/scale);
%             v = reshape(v(lst), height/scale, width/scale);
%             if timestep==8
%                 subplot(3,3,tt)
%             elseif timestep==16
%                 subplot(4,4,tt)
%             end
%             imagesc(newim(:,:,:,tt)/255), colormap(gray(255))
% %             imagesc(newim(:,:,tt)), colormap(gray(255))
%             hold on
%             quiver(gx, gy, v, u, 1, 'r')
%         end
%         maximize(h);
%         saveas(h, sprintf('results/%s_flow%02d.tif', sequence, lv));
        for tt=1:timestep
            for ch=1:3
                compim(:,:,ch) = [img.origcolorim(:,:,ch,tt), zeros(size(img.origcolorim,1), 20), img.newcolorim(:,:,ch,tt)];
            end
            imwrite(compim/255, sprintf('results/%s_results_ind%02d_%02d.tif', sequence, lv, tt+fnum-1));
        end
    end
end
