function newim = getRecError(im, pwy, pwx, ptime, coeffs)

if max(abs(coeffs.x)>5 | abs(coeffs.y)>5)
    coeffs.x(:) = 0;
    coeffs.y(:) = 0;
end
    
global lambda pwmax coefbit gamma
% compute the lines
for tt=1:ptime
    surf_x(tt) = round(sum(coeffs.x(1:tt)));
    surf_y(tt) = round(sum(coeffs.y(1:tt)));
end

%find the line extrema
xmax = max(round(surf_x));
ymax = max(round(surf_y));
xmin = min(round(surf_x));
ymin = min(round(surf_y));
xstepsize = 40;
ystepsize = 40;
xstart = -xmax;
xend = -xmin;
ystart = -ymax;
yend = -ymin;
if xmax==xmin
    xstepsize = 0;
    xstart = 1;
    xend = pwx;
end
if ymax==ymin
    ystepsize = 0;
    ystart = 1;
    yend = pwy;
end
LOOPFLAG = 1;
counter = 0;
while (LOOPFLAG & counter<10)
    clear lines_x lines_y lines_t
    [lines_x lines_y, lines_t] = meshgrid(xstart:xend, ystart:yend, 1:ptime);
    for tt=1:ptime
        lines_x(:,:,tt) = (lines_x(:,:,tt) + surf_x(tt));
        lines_y(:,:,tt) = (lines_y(:,:,tt) + surf_y(tt));
    end
    
    lsy = find((lines_y(:) > pwy) | (lines_y(:) <= 0));
    lines_x(lsy) = nan;
    lines_y(lsy) = nan;
    
    lsx = find((lines_x(:) > pwx) | (lines_x(:) <= 0));
    lines_x(lsx) = nan;
    lines_y(lsx) = nan;
    [szy szx szt] = size(lines_x);    
    ls = find(~isnan(lines_x(:)));
    if max(size(ls(:))) == (pwy*pwx*ptime)
        LOOPFLAG = 0;
    else
        xstart = xstart-xstepsize;
        xend = xend+xstepsize;
        ystart = ystart-ystepsize;
        yend = yend+ystepsize;
        [xstart ystart xend yend xmax+xstart max(size(ls)) (pwy*pwx*ptime)];
    end
    counter = counter+1;
end
if counter>=10
    sprintf('hede');
    recimg = [];
    recerr = inf;
    bandcoef = [];
    bitcost = [];
    return
end
lines_y(lsy) = nan;
lines_t(lsy) = nan;
    
lines_y(lsx) = nan;
lines_t(lsx) = nan;

[gry, grx grt] = size(lines_x);
for x=1:grx
    nantest = isnan(lines_x(:,x,:));
    if ~isempty(find(nantest==0))
        xmin = x;
        break;
    end
end
for x=grx:-1:1
    nantest = isnan(lines_x(:,x,:));
    if ~isempty(find(nantest==0))
        xmax = x;
        break;
    end
end


for y=1:gry
    nantest = isnan(lines_x(y,:,:));
    if ~isempty(find(nantest==0))
        ymin = y;
        break;
    end
end
for y=gry:-1:1
    nantest = isnan(lines_x(y,:,:));
    if ~isempty(find(nantest==0))
        ymax = y;
        break;
    end
end


% coords = coords(ymin:ymax, xmin:xmax,:);
lines_x = lines_x(ymin:ymax, xmin:xmax,:);
lines_y = lines_y(ymin:ymax, xmin:xmax,:);
[coordx coordy coordt] = meshgrid(1:pwx, 1:pwy, 1:ptime);
ls = find(~isnan(lines_x));
grx = lines_x;
grx(ls) = coordx;
gry = lines_y;
gry(ls) = coordy;
map = lines_x;
map(ls) = 1:pwy*pwx*ptime;

warpedim = map;
warpedim(ls) = im(map(ls));
newwarpedim = warpedim;        

[height, width, time] = size(map);
for y=1:height
    for x=1:width
        grlst = find(~isnan(map(y,x,:)));
        pixvector = warpedim(y + (x-1)*height + (grlst-1)*height*width);
        nanlst = find(isnan(pixvector));
        if ~isempty(nanlst)
            newpixvector = completeData(pixvector, nanlst);
            newwarpedim(y + (x-1)*height + (grlst-1)*height*width) = newpixvector;
        else
            newwarpedim(y + (x-1)*height + (grlst-1)*height*width) = ...
                warpedim(y + (x-1)*height + (grlst-1)*height*width);
        end
    end
end

newim = newwarpedim;
newim(map(ls)) = newwarpedim(ls);
% [height, width, time] = size(map);
% for y=1:height
%     for x=1:width
%         grlst = find(~isnan(map(y,x,:)));
%         pixvector = warpedim(y + (x-1)*height + (grlst-1)*height*width);
%         nanlst = find(isnan(pixvector));
%         if ~isempty(nanlst)
%             newpixvector = completeData(pixvector, nanlst);
%             newwarpedim(y + (x-1)*height + (grlst-1)*height*width) = newpixvector;
%         else
%             newwarpedim(y + (x-1)*height + (grlst-1)*height*width) = warpedim(y + (x-1)*height + (grlst-1)*height*width);
%         end
%     end
% end
% 
% newim = im;
% newim(map(ls)) = newwarpedim(ls);