function [flow, flowerr] = processSequence(img, flip, pwmax, timestep)

tlevel = 1;
im = img.im;
thresh = 10;
global level
[height width time] = size(im);
if flip == 1
    im_x = img.imx;
    im_y = img.imy;
    im_t = img.imt;
elseif flip == 2
    im_x = img.imht;
    im_y = img.imhy;
    im_t = img.imhx;
    flip_x = flipSequence(im_x,1);
    flip_y = flipSequence(im_y,1);
    flip_t = flipSequence(im_t,1);
    flip_xx = flip_x.*flip_x;
    flip_yy = flip_y.*flip_y;
    flip_tt = flip_t.*flip_t;
    flip_xy = flip_x.*flip_y;
    flip_xt = flip_x.*flip_t;
    flip_yt = flip_y.*flip_t;
elseif flip == 3
    im_x = img.imvx;
    im_y = img.imvt;
    im_t = img.imvy;
    flip_x = flipSequence(im_x,2);
    flip_y = flipSequence(im_y,2);
    flip_t = flipSequence(im_t,2);
    flip_xx = flip_x.*flip_x;
    flip_yy = flip_y.*flip_y;
    flip_tt = flip_t.*flip_t;
    flip_xy = flip_x.*flip_y;
    flip_xt = flip_x.*flip_t;
    flip_yt = flip_y.*flip_t;
elseif flip == 0
    flow = [];
    im_t = img.imt;
end

if flip > 0
    im_xx = im_x.*im_x;
    im_yy = im_y.*im_y;
    im_tt = im_t.*im_t;
    im_xt = im_x.*im_t;
    im_xy = im_x.*im_y;
    im_yt = im_y.*im_t;
%     for lv = level:-1:1
    for lv = (level+1):-1:1
        pw = pwmax*2^-(lv-1);
        ind = 1;
        flows(lv).x = zeros(height,width,time);
        flows(lv).y = flows(lv).x;
        flows(lv).img = flows(lv).x;
        for t=1:timestep:time
            for x=1:pw:width
                if(x+pw-1>width)
                    continue;
                end
                for y=1:pw:height
                    if(y+pw-1>height)
                        continue;
                    end
                    subgof = im(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    subgof_x = im_x(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    subgof_y = im_y(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    subgof_t = im_t(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    subgof_xx = im_xx(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    subgof_yy = im_yy(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    subgof_tt = im_tt(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    subgof_xy = im_xy(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    subgof_xt = im_xt(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    subgof_yt = im_yt(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    subgof_tt = im_tt(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    if flip==1
                        [flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).err, ...
                                flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).coeffs, ...
                                flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).best, ...
                                flowerr(lv).err(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)), ...
                                flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).dims] = ...
                                computeGeoFlowLin(subgof, subgof_x, ...
                                subgof_y, subgof_t, subgof_xx, subgof_yy, subgof_tt, subgof_xy, subgof_yt, subgof_xt, ...
                                x, y, t, height, width, time, thresh);
                        
                    elseif flip ==2
                        [flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).err, ...
                                flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).coeffs, ...
                                flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).best, ...
                                flowerr(lv).err(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)), ...
                                flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).dims] = ...
                                computeGeoFlowLin(flipSequence(subgof,1), ...
                            flipSequence(subgof_t,1), flipSequence(subgof_y,1), flipSequence(subgof_x,1), flipSequence(subgof_tt,1), ...
                            flipSequence(subgof_yy,1), flipSequence(subgof_xx,1), flipSequence(subgof_yt,1), flipSequence(subgof_xy,1), ...
                            flipSequence(subgof_xt,1), t, y, x, height, time, width, thresh, fid);
                        
                    elseif flip ==3
                        [flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).err, ...
                                flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).coeffs, ...
                                flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).best, ...
                                flowerr(lv).err(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)), ...
                                flow(lv).geo(floor(y/pw+1),floor(x/pw+1),floor(t/timestep+1)).dims] = ...
                                computeGeoFlowLin(flipSequence(subgof,2), ...
                            flipSequence(subgof_x,2), flipSequence(subgof_t,2), flipSequence(subgof_y,2), flipSequence(subgof_xx,2), ...
                            flipSequence(subgof_tt,2), flipSequence(subgof_yy,2), flipSequence(subgof_xt,2), flipSequence(subgof_yt,2), ...
                            flipSequence(subgof_xt,2), x, t, y, time, height, width, thresh, fid);
                        
%                         flow(lv).img(t:t+timestep-1, x:x+pw-1, y:y+pw-1) = recimg;
%                         for ft=1:pw
%                             flow(lv).x(y+ft-1, x:x+pw-1, t:t+timestep-1) = flow(lv,ind).cx(ft);
%                             flow(lv).t(y+ft-1, x:x+pw-1, t:t+timestep-1) = flow(lv,ind).ct(ft);
%                         end
                    end                    
                    ind = ind+1;
                    if mod(ind,50)==0
                        ind
                    end
                end
            end
        end
        ind
%         if flip==2
%             flow(lv).img = flipSequence(flow(lv).img, 1);
%         elseif flip==3
%             flow(lv).img = flipSequence(flow(lv).img, 2);
%         end
%         %display the flows
%         if (displayFlow)
%             if flip==1
%                 for ft=1:timestep
%                     figure
%                     imagesc(im(:,:,t+ft-1))
%                     colormap(gray(255))
%                     hold on
%                     quiver(flows(lv).x(:,:,t+ft-1), flows(lv).y(:,:,t+ft-1),1)
%                 end
%             elseif flip==2
%                 plt = zeros(size(im(:,:,1)));
%                 for ft=1:timestep
%                     figure
%                     %                 imagesc(reshape(im(:,x,:),height, time))
%                     imagesc(im(:,:,t+ft-1))
%                     colormap(gray(255))
%                     hold on
%                     quiver(plt, flows(lv).y(:,:,t+ft-1),0)
%                 end
%                 pause
%                 close all
%             elseif flip==3
%                 plt = zeros(size(im(:,:,1)));
%                 for ft=1:timestep
%                     figure
%                     %                 imagesc(reshape(im(:,x,:),height, time))
%                     imagesc(im(:,:,t+ft-1))
%                     colormap(gray(255))
%                     hold on
%                     quiver(flows(lv).x(:,:,t+ft-1),plt,0)
%                 end
%                 pause
%                 close all
%             end
%         end
    end
else
    for lv = level:-1:1
        pw = pwmax*2^-lv;
        ind = 1;
        for t=1:timestep:time
            for x=1:pw:width
                if(x+pw-1>width)
                    continue;
                end
                for y=1:pw:height
                    if(y+pw-1>height)
                        continue;
                    end
%                     subgof = im(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
%                     [recerr, bandcoef, recimg] = decomposeResampledImage(subgof, thresh);
%                     flow(lv,ind).coeffs = bandcoef;
%                     flow(lv,ind).img = recimg;
                    subgof_t = im_t(y:y+pw-1, x:x+pw-1, t:t+timestep-1);
                    flowerr(lv).err(floor(y/pw+1), floor(x/pw+1), floor(t/timestep+1)) = sum(subgof_t(:).^2);
                        
%                     for ft=1:timestep
%                         flow(lv).img(y:y+pw-1, x:x+pw-1, t:t+timestep-1) = recimg;
%                     end
                    ind = ind+1;
                        
                    if mod(ind,50)==0
                        ind
                    end
                end
            end
        end
    end
end
