function newim = resampleGOF(gof, x, y, cpx, cpy, origh, origw)

DISPLAY = 0;
[gofh, gofw, time] = size(gof);
ftime = max(size(cpx));
% convert flow into lines
for t=1:ftime
    flx(t) = sum(cpx(1:t));
    fly(t) = sum(cpy(1:t));
end
xstart = x + flx;
ystart = y + fly;
xend = xstart + origw - 1;
yend = ystart + origh - 1;

ls = find(xstart<1);
if ~isempty(ls)
    offset = ceil(max(abs(xstart(ls)))) + 1;
    xstart = xstart + offset;
end
ls = find(xend > gofw);
if ~isempty(ls)
    offset = ceil(max(abs(xend(ls)))) - gofw;
    xend = xend - offset;
end

ls = find(ystart<1);
if ~isempty(ls)
    offset = ceil(max(abs(ystart(ls)))) + 1;
    ystart = ystart + offset;
end
ls = find(yend > gofh);
if ~isempty(ls)
    offset = ceil(max(abs(yend(ls)))) - gofh;
    yend = yend - offset;
end
w = round(xend(1) - xstart(1)) + 1;
h = round(yend(1) - ystart(1)) + 1;
if( h<=2 | w<=2)
    newim = [];
    return
end
newim.im = zeros(h,w,time);

[ex, ey] = meshgrid(1:w, 1:h);
elst = (ex(:)-1)*h + ey(:);
for t=1:ftime
    [newx, newy] = meshgrid(xstart(t):xend(t), ystart(t):yend(t));
    xtop = ceil(newx);
    xbtm = floor(newx);
    ytop = ceil(newy);
    ybtm = floor(newy);
    
    if( (xtop(1) == xbtm(1)) & (ytop(1) == ybtm(1)) )
        pntlist = (xtop(:)-1)*gofh + ytop(:) + (t-1)*gofh*gofw;
        newim.im(elst + (t-1)*h*w) = gof(pntlist);
    elseif( (xtop(1)==xbtm(1)) & (ytop(1)~=ybtm(1)) )
        pntlist1 = (xtop(:)-1)*gofh + ytop(:) + (t-1)*gofh*gofw;
        pntlist2 = (xtop(:)-1)*gofh + ybtm(:) + (t-1)*gofh*gofw;
        coef1 = newy(1)-ybtm(1);
        coef2 = ytop(1)-newy(1);
        newim.im(elst + (t-1)*h*w) = coef1*gof(pntlist1) + coef2*gof(pntlist2);
    elseif( (xtop(1)~=xbtm(1)) & (ytop(1)==ybtm(1)) )
        pntlist1 = (xtop(:)-1)*gofh + ytop(:) + (t-1)*gofh*gofw;
        pntlist2 = (xbtm(:)-1)*gofh + ytop(:) + (t-1)*gofh*gofw;
        coef1 = newx(1)-xbtm(1);
        coef2 = xtop(1)-newx(1);
        newim.im(elst + (t-1)*h*w) = coef1*gof(pntlist1) + coef2*gof(pntlist2);
    elseif( (xtop(1)~=xbtm(1)) & (ytop(1)~=ybtm(1)) )
        pntlist1 = (xtop(:)-1)*gofh + ytop(:) + (t-1)*gofh*gofw;
        pntlist2 = (xtop(:)-1)*gofh + ybtm(:) + (t-1)*gofh*gofw;
        pntlist3 = (xbtm(:)-1)*gofh + ytop(:) + (t-1)*gofh*gofw;
        pntlist4 = (xbtm(:)-1)*gofh + ybtm(:) + (t-1)*gofh*gofw;
        coef1 = newx(1)-xbtm(1);
        coef2 = xtop(1)-newx(1);
        coef3 = newy(1)-ybtm(1);
        coef4 = ytop(1)-newy(1);
        newim.im(elst + (t-1)*h*w) = coef1*coef3*gof(pntlist1)+ coef1*coef4*gof(pntlist2) + ...
            coef2*coef3*gof(pntlist3) + coef2*coef4*gof(pntlist4);
    end
end

if DISPLAY
    figure
    for t=1:ftime
        subplot(8,2,2*t-1)
        imagesc(gof(y:y+origh, x:x+origw, t)), colormap(gray(255))
        subplot(8,2,2*t)
        imagesc(newim.im(:,:,t)), colormap(gray(255))
        pause
    end
end
    