function finalim = resampleGOF3(gof, cx, cy)

global pwmax
finalim = zeros(pwmax-1,pwmax-1);
finalim(:) = nan;

elst = 1:(pwmax-1)*(pwmax-1);

xstart = 1+cx;
ystart = 1+cy;
xend = pwmax+cx-1;
yend = pwmax+cy-1;

[newx, newy] = meshgrid(xstart:xend, ystart:yend);
xtop = ceil(newx);
xbtm = floor(newx);
ytop = ceil(newy);
ybtm = floor(newy);
[gofh, gofw] = size(gof);

if( (xtop(1) == xbtm(1)) & (ytop(1) == ybtm(1)) )
    pntlist = (xtop(:)-1)*gofh + ytop(:);
    finalim(elst) = gof(pntlist);
elseif( (xtop(1)==xbtm(1)) & (ytop(1)~=ybtm(1)) )
    pntlist1 = (xtop(:)-1)*gofh + ytop(:);
    pntlist2 = (xtop(:)-1)*gofh + ybtm(:);
    coef1 = newy(1)-ybtm(1);
    coef2 = ytop(1)-newy(1);
    finalim(elst) = coef1*gof(pntlist1) + coef2*gof(pntlist2);
elseif( (xtop(1)~=xbtm(1)) & (ytop(1)==ybtm(1)) )
    pntlist1 = (xtop(:)-1)*gofh + ytop(:);
    pntlist2 = (xbtm(:)-1)*gofh + ytop(:);
    coef1 = newx(1)-xbtm(1);
    coef2 = xtop(1)-newx(1);
    finalim(elst) = coef1*gof(pntlist1) + coef2*gof(pntlist2);
elseif( (xtop(1)~=xbtm(1)) & (ytop(1)~=ybtm(1)) )
    pntlist1 = (xtop(:)-1)*gofh + ytop(:);
    pntlist2 = (xtop(:)-1)*gofh + ybtm(:);
    pntlist3 = (xbtm(:)-1)*gofh + ytop(:);
    pntlist4 = (xbtm(:)-1)*gofh + ybtm(:);
    coef1 = newx(1)-xbtm(1);
    coef2 = xtop(1)-newx(1);
    coef3 = newy(1)-ybtm(1);
    coef4 = ytop(1)-newy(1);
    finalim(elst) = coef1*coef3*gof(pntlist1)+ coef1*coef4*gof(pntlist2) + ...
        coef2*coef3*gof(pntlist3) + coef2*coef4*gof(pntlist4);
end
